"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const camelcase_1 = __importDefault(require("camelcase"));
const typescript_1 = __importDefault(require("typescript"));
let scanner;
function scanToken(text) {
    if (!scanner) {
        scanner = typescript_1.default.createScanner(typescript_1.default.ScriptTarget.Latest, false, typescript_1.default.LanguageVariant.Standard);
    }
    scanner.setText(text);
    scanner.scan();
    return scanner;
}
function isValidIdentifier(text) {
    const scan = scanToken(text);
    return scan.isIdentifier()
        && scan.getTextPos() === text.length
        && scan.getTokenPos() === 0;
}
function sanitizeIdentifier(text) {
    text = camelcase_1.default(text.replace(/^\d+/, '')).replace(/[^A-Za-z0-9_$]/, '') || 'default_1';
    return isValidIdentifier(text) ? text : text + '_1';
}
exports.default = sanitizeIdentifier;
//# sourceMappingURL=sanitizeIdentifier.js.map